#' @importFrom methods new
#' @importFrom bigmemory big.matrix describe
#' @importFrom stringi stri_paste
#' @importFrom hash del
#' @importFrom stats coefficients gaussian glm median quantile
#' @importFrom utils capture.output
EMJMCMC2016 <- methods::setRefClass(
  Class = "EMJMCMC2016",
  fields = list(
    estimator.args = "list",
    max.cpu = "integer",
    objective = "integer",
    p.prior = "numeric",
    min.N = "integer",
    estimator = "function",
    parallelize = "function",
    parallelize.global = "function",
    parallelize.hyper = "function",
    min.N.randomize = "integer",
    max.N.randomize = "integer",
    type.randomize = "integer",
    thin_rate = "integer",
    aa = "numeric",
    cc = "numeric",
    printable.opt = "logical",
    fobserved = "vector",
    switch.type = "integer",
    n.size = "integer",
    deep.method = "integer",
    sup.large.n = "integer",
    LocImprove = "array",
    max.N = "integer",
    save.beta = "logical",
    keep.origin = "logical",
    recalc.margin = "numeric",
    max.N.glob = "integer",
    min.N.glob = "integer",
    max.cpu.glob = "integer",
    max.cpu.hyper = "integer",
    p.add.default = "numeric",
    switch.type.glob = "integer",
    isobsbinary = "array",
    filtered = "vector",
    fparam = "vector",
    latnames = "vector",
    fparam.pool = "character",
    p.add = "array",
    latent.formula = "character",
    Nvars = "integer",
    seed = "numeric",
    M.nd = "integer",
    locstop.nd = "logical",
    pool.cor.prob = "logical",
    M.mcmc = "integer",
    SA.param = "list",
    p.epsilon = "numeric",
    p.allow.tree = "numeric",
    p.nor = "numeric",
    p.and = "numeric",
    sigmas.prob = "numeric",
    del.sigma = "numeric",
    pool.cross = "numeric",
    gen.prob = "numeric",
    sigmas = "vector",
    p.allow.replace = "numeric",
    max.tree.size = "integer",
    double.hashing = "logical",
    prand = "numeric",
    hash.length = "integer",
    update.marg.mc = "logical",
    Nvars.max = "integer",
    Nvars.init = "integer",
    last.mutation = "integer",
    allow_offsprings = "integer",
    mutation_rate = "integer",
    g.results = "big.matrix"
  )
)
